<?php
	// ======================================== \
	// Package: Mihalism Multi Host
	// Version: 5.0.0
	// Copyright (c) 2007, 2008, 2009 Mihalism Technologies
	// License: http://www.gnu.org/licenses/gpl.txt GNU Public License
	// LTE: 1250934721 - Saturday, August 22, 2009, 05:52:01 AM EDT -0400
	// ======================================== /
	
	$mmhclass = new stdClass;

	ini_set("log_errors", 1);
	ini_set("display_errors", 0);
	ini_set("register_globals", 0);
	ini_set("memory_limit", "128M");
	ini_set("post_max_size", "128M");
	
	$mmhclass->info->root_path = sprintf("%s/", realpath(".."));
	$mmhclass->info->upgrade_path = sprintf("%s/", realpath("."));

	require_once "{$mmhclass->info->root_path}source/includes/config.php";
	require_once "{$mmhclass->info->upgrade_path}source/includes/config.php";
	require_once "{$mmhclass->info->upgrade_path}source/includes/database.php";
	require_once "{$mmhclass->info->upgrade_path}source/includes/functions.php";
	
	$mmhclass->db = new mmhclass_mysql_driver();
	$mmhclass->funcs = new mmhclass_core_functions();
	
	$mmhclass->input->get_vars = $mmhclass->funcs->clean_array($_GET);  
	$mmhclass->input->post_vars = $mmhclass->funcs->clean_array($_POST);
	$mmhclass->input->file_vars = $mmhclass->funcs->clean_array($_FILES);
	$mmhclass->input->server_vars = $mmhclass->funcs->clean_array($_SERVER);

	$mmhclass->info->page_url = $mmhclass->funcs->fetch_url(true, false, true);
	$mmhclass->info->base_url = $mmhclass->funcs->fetch_url(false, false, false);
	$mmhclass->info->current_page = round(($mmhclass->funcs->is_null($mmhclass->input->get_vars['page']) == false && $mmhclass->input->get_vars['page'] >= 1) ? $mmhclass->input->get_vars['page'] : 1);
	$mmhclass->info->script_path = ((dirname($mmhclass->input->server_vars['php_self']) !== "/") ? (dirname($mmhclass->input->server_vars['php_self'])."/") : dirname($mmhclass->input->server_vars['php_self']));
			
	$mmhclass->db->connect($mmhclass->info->config['sql_host'], $mmhclass->info->config['sql_username'], $mmhclass->info->config['sql_password'], $mmhclass->info->config['sql_database']);
	
	/* Not a pretty upgrader, but she gets the job done. *pets* */
	
	readfile("{$mmhclass->info->upgrade_path}source/public_html/page_header.html");
	
	switch ($mmhclass->input->get_vars['act']) {	
		case "upgrade":
			$server_token = base64_encode(serialize(array("url" => $mmhclass->info->base_url, "time" => time(), "admin" => $mmhclass->input->server_vars['server_admin'], "version" => $mmhclass->info->upgrade_to, "site" => $mmhclass->input->server_vars['http_host'])));
			$server_license = $mmhclass->funcs->get_http_content("http://callhome.mihalism.net/multihost/?id={$server_token}", 1);
				
			require_once "{$mmhclass->info->upgrade_path}source/includes/upgrade_queries/{$mmhclass->info->upgrade_queries}.php";
	
			echo "Starting Upgrader...";
			echo "<br /><br />";
			echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			echo "<b>1.</b> MySQL upgrade starting... ";
			echo "<br /><br />";
			
			foreach ($mmhclass->db->upgrade_queries as $id => $the_query) {
				if (is_array($the_query) == true) {
					$result = $mmhclass->db->query($the_query['0'], $the_query['1']);
				} else {
					$result = $mmhclass->db->query($the_query);
				}
				
				echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
				if ($result == false) {
					echo sprintf("Query #%s: <span style=\"color: #F00;\"><strong>Failed!</strong></span><br />", ($id + 1));
				} else {
					echo sprintf("Query #%s: <span style=\"color: #096\"><strong>Executed.</strong></span><br />", ($id + 1));
				}
			}
			
			echo "<br />";
			echo "<b>Upgrade Complete!</b>";
			echo "<br /><br />";
			echo "Delete this upgrader as soon as possible for security purposes.";
			break;
		default:
			echo "Please confirm the following information before continuing this upgrade of Mihalism Mulit Host.
			<br /><br />
			<b>Upgrading To</b>: Mihalism Multi Host v{$mmhclass->info->upgrade_to}<br />
			<b>Upgrading From</b>: Mihalism Multi Host v{$mmhclass->info->upgrade_from}
			<br /><br />
			<a href=\"index.php?act=upgrade\">&raquo; Continue With Upgrade &raquo;</a>
			<br /><br />
			<b style=\"color: #F00;\">WARNING</b>: There is no undo when you run a upgrade, so backup everything before continuing!";
	}
	
	readfile("{$mmhclass->info->upgrade_path}source/public_html/page_footer.html");
	
	exit;

?>
